//lrt.h
#ifndef LRT_H
#define LRT_H

class Matrix;
class Vector;

class LRT{
  int order;//order of the AR model
  int n;//sample size
  double* pDat;//the data
  double* pLRT;//raw LRT statistics
  double sig2hat;//variance estimator

  //utilities to check memory allocation
  void memoryCheck(double* p);
  void memoryCheck(double** p);

  //initialization functions
  Matrix initX(int t);
  Vector initXTx(Matrix& A, int low, int up);
  double initxTx(int low, int up);

  //updating functions
  void updateXVec(Vector& a, int t);
  void updateXTXinv(Matrix& A, Vector& x);
  void updateXTx(Vector& A, int t);

public:
  
  LRT(int Order, int N, double* PDat);//constructor
  ~LRT();//destructor
  void testStat();//computes sig2hat and fills pLRT

  //accessors
  double operator[](int t){return pLRT[t];}
  double getSig2Hat(){return sig2hat;}
};

#endif
