//lrtDr.cpp
#include <iostream>
#include <fstream>
#include <cstdlib>
#include "lrt.h"

using std::cout; using std::endl;

int main(int argc, char** argv){
  int n = atoi(argv[1]);//sample size is argv[1]
  int order = atoi(argv[2]);//order for AR model is argv[2]*/
  double* pA = new double[n];//pointer to hold the data
  if(pA == 0){
    cout << "Memory allocation failed" << endl;
    exit(1);
  }

  //read in data from file specified in argv[3]
  std::ifstream fIn(argv[3]);
  if(!fIn.is_open()){
    cout << "Error opening file" << endl;
    exit(1);
  }
  for(int t = 0; t < n; t++)
    fIn >> pA[t];
    fIn.close();

  //now compute the test statistics
  LRT lrtEx(order, n, pA);
  lrtEx.testStat();
  int tau;
  double tStat = 0;
  for(int t = 0; t < n - 3*order - 3; t++){
    if(lrtEx[t] >= tStat){
      tStat = lrtEx[t];
      tau = t + 2*(order + 1);
    }
  }
  cout << "The test statistic is " << tStat << endl;
  cout << "The estimated change point is " << tau << endl;
  return 0;
}

