//lrtDr.cpp
#include <iostream>
#include <fstream>
#include <cstdlib>
#include "matrix.h"
#include "vector.h"
#include "lrt.h"
#include <ctime>
using std::cout; using std::endl;

int main(int argc, char** argv){

  int order = 2, n = 16;
  double* pA;
  double sec;
  clock_t b;

  for(int j = 0; j <= 20; j++){
    n = 2*n;
    pA = new double[n];//pointer to hold the data
    if(pA == 0){
      cout << "Memory allocation failed" << endl;
      exit(1);
    }
    srand(123);
    for(int t = 0; t < n; t++){
      pA[t] = (double)(rand())/(double)(RAND_MAX);
    }
    b = clock();
    //now compute the test statistics
    LRT lrtEx(order, n, pA);
    lrtEx.testStat();
    sec = (double)(clock() - b)/(double)CLOCKS_PER_SEC;
    cout << sec << endl;
    delete[] pA;
  }
  return 0;
}

