//lrtDr.cpp
#include <iostream>
#include <cstdlib>
#include "lrtMP.h"
#include <ctime>
#include <omp.h>

using std::cout; using std::endl;

int main(int argc, char** argv){

  int order = 2, n = 16;
  double t1, t2;
  double* pA;
  double b=0;

  for(int j = 0; j <= 20; j++){
    n = 2*n;
    pA = new double[n];//pointer to hold the data
    if(pA == 0){
      cout << "Memory allocation failed" << endl;
      exit(1);
    }
    srand(123);
    for(int t = 0; t < n; t++){
      pA[t] = (double)(rand())/(double)(RAND_MAX);
    }
    //now compute the test statistics

    int nP = omp_get_num_procs();

    int myRank;
    LRT lrtEx(order, n, pA);
    omp_set_num_threads(2);                              
    b = omp_get_wtime();

#pragma omp parallel private(myRank)
    {
#pragma omp sections
      {
#pragma omp section
        lrtEx.testStatForward();

#pragma omp section
        lrtEx.testStatBackward();
      }
    }
    lrtEx.testStat();

    t2 = (omp_get_wtime() - b);

    b = omp_get_wtime();

    lrtEx.testStatForward();
    lrtEx.testStatBackward();
    lrtEx.testStat();
 
    t1 = (omp_get_wtime() - b);

    delete[] pA;
    cout << t1 << " " << t2 << endl;
  }
  return 0;
}

