//lrtMP.h
#ifndef LRTMP_H
#define LRTMP_H

class Matrix;
class Vector;

class LRT{
  int order;//order of the AR model
  int n;//sample size
  double* pDat;//the data
  double** pQ;//Q(s, t) statistics
  double* pLRT;//raw LRT statistics

  //utilities to check memory allocation
  void memoryCheck(double* p);
  void memoryCheck(double** p);

  //initialization functions
  Matrix initX(int t);
  Vector initXTx(Matrix& A, int low, int up);
  double initxTx(int low, int up);

  //updating functions
  void updateXVec(Vector& a, int t);
  void updateXTXinv(Matrix& A, Vector& x);
  void updateXTx(Vector& A, int t);

public:
  LRT(){}
  LRT(int Order, int N, double* PDat);//constructor
  ~LRT();//destructor
  void testStatForward();//forward recursion
  void testStatBackward();//backward recursion
  void testStatMP(int i){
    if(i == 0 || i == 2 || i == 4 || i == 6) testStatForward();
    if(i == 1 || i == 3 || i == 5 || i == 7) testStatBackward();
  }
  void testStat();//combines the forward and backward results

  //accessors
  double operator[](int t){return pLRT[t];}
};

#endif
